/* * * * * * * * * * * * * *  INITIALIZATIONS  * * * * * * * * * * * * * *\
 * findgfx () [void]                                                     *
 * gfxmode () [void macro]                                               *
 * gogfx (), gotxt () [void macro]                                       *
 * [global var] screen [unsigned char far*]                              *
 *   pointer to the screen buffer                                        *
 * [global var] vscreen [unsigned char*]                                 *
 *   pointer to a self-defined virtual screen                            *
 *                                                                       *
 * * * * * * * * * * * * * * * *  DRAWING  * * * * * * * * * * * * * * * *
 * pset (x,y,color) [void macro]                                         *
 * dpset (x,y,color) [void macro]
 * point (x,y) [unsigned char macro]                                     *
 *                                                                       *
 * * * * * * * * * * * * * * * PAGE FLIPPING * * * * * * * * * * * * * * *
 * flip () [void macro]                                                  *
 *                                                                       *
 * * * * * * * * * * * * * * * MISCELLANEOUS * * * * * * * * * * * * * * *
 * loadscr (name,pos) [void macro]                                       *
 *   reads data from the file onto the screen buffer                     *
 * savescr (name,pos) [void macro]                                       *
 *   writes data from the screen buffer onto the file                    *
 * scrup (top,bottom,amount) [void macro]                                *
 * scrdn (top,bottom,amount) [void macro]                                *
 * scrlf (top,bottom,amount) [void macro]                                *
 * scrrt (top,bottom,amount) [void macro]                                *
 *   scrolls the screen between top Y and bottom Y by the given amount   *
 * split (y) [void]                                                      *
 *   splits the screen after vertical scan line y                        *
 * disp (pos) [void macro]                                               *
 *   ?forgot?                                                            *
 *                                                                       *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


// ========================== INITIALIZATIONS ==========================
#define MAXX 320
#define MAXY 200
unsigned char far* screen =
  (unsigned char far*) ((void _seg*)(0xA000) + (void near*)(0));
unsigned char far vscreen[0xfa00];
typedef unsigned size_t;
extern "C" {
  void*         calloc   (size_t, size_t);
  void far *far _fmemcpy (void far *, const void far *, size_t);
  void          free     (void *);
  void          exit     (int);
}
char findgfx (void) {
  char n;
  asm { mov ax, 0x1a00; int 0x10; mov n, al }
  return (n == 0x1a);
}
void gotxt (void) { asm { mov ax, 0x03; int 0x10 } }
void gogfx (void) { asm { mov ax, 0x13; int 0x10 } }
/*void txtmode (void) { free (vscreen); gotxt (); }
void gfxmode (void) {
  vscreen = (unsigned char*) calloc (0xFA00,1);
  if (vscreen == 0) exit (99); gogfx ();
} */
#define txtmode gotxt
#define gfxmode gogfx

// ============================== DRAWING ==============================
#define pset(x,y,c)  vscreen[(x)+MAXX*(y)]  = c
#define dpset(x,y,c)  screen[(x)+MAXX*(y)]  = c
#define xpset(x,y,c) vscreen[(x)+MAXX*(y)] ^= c
#define point(x,y)   vscreen[(x)+MAXX*(y)]
#define dpoint(x,y)   screen[(x)+MAXX*(y)]
#define cls(c) box(0,0,MAXX,MAXY,c);


// =========================== PAGE FLIPPING ===========================
void inline flip (void) { _fmemcpy(screen,vscreen,0xFA00); }


// =========================== MISCELLANEOUS ===========================
#define loadscr(name,pos) file = fopen(name,"rb"); fseek (file, pos, 0);\
  fread(screen, 0xFA00, 1, file); fclose(file)
#define savescr(name,pos) file = fopen(name,"wb"); fseek (file, pos, 0);\
  fwrite(screen, 0xFA00, 1, file); fclose(file);
#define scrup(top,bot,num) _fmemcpy(screen+MAXX*top,screen+MAXX*(top+num),\
  MAXX*(bot-top-num+1))
#define scrdn(top,bot,num) _fmemcpy(screen+MAXX*(top+num),screen+MAXX*top,\
  MAXX*(bot-top-num+1))
#define scrlf(top,bot,num) for (int i=top;i<=bot;i++)\
  _fmemcpy(screen+MAXX*i,screen+MAXX*i+num,MAXX-num)
#define scrrt(top,bot,num) for (int i=top;i<=bot;i++)\
  _fmemcpy(screen+MAXX*i+num,screen+MAXX*i,MAXX-num)
/*void split (int size) {
  int n;
  outp (0x3d4, 24); outp (0x3d5, size); size >>= 8;
  outp (0x3d4, 7); n = inp (0x3d5);
  outp (0x3d5, (n & -17) + ((size & 1) << 4));
  outp (0x3d4, 9); n = inp (0x3d5);
  outp (0x3d5, (n & -65) + ((size & 2) << 6));
} */
#define disp(pos) vwait; asm {\
  mov bx, pos; mov dx, 0x03d4; mov al, 0x0c; out dx, al;\
  inc dx; mov al, bh; out dx, al;\
  mov dx, 0x03d4; mov al, 0x0d; out dx, al;\
  inc dx; mov al, bl; out dx, al}


#include <pjsgfx.h>
